您的位置:首页 > 其它

CodeForces - 698B Fix a Tree(并查集)

2017-03-17 10:37 393 查看
Fix a Tree

A tree is an undirected connected graph without cycles.

Let's consider a rooted undirected tree with n vertices, numbered 1 through n.
There are many ways to represent such a tree. One way is to create an array with n integers p1, p2, ..., pn,
where pi denotes
a parent of vertex i (here, for convenience a root is considered its own parent).


For
this rooted tree the array p is [2, 3, 3, 2].

Given a sequence p1, p2, ..., pn,
one is able to restore a tree:

There must be exactly one index r that pr = r.
A vertex r is a root of the tree.

For all other n - 1 vertices i,
there is an edge between vertex i and vertex pi.

A sequence p1, p2, ..., pn is
called valid if the described procedure generates some (any) rooted tree. For example, for n = 3 sequences (1,2,2), (2,3,1) and (2,1,3) are
not valid.

You are given a sequence a1, a2, ..., an,
not necessarily valid. Your task is to change the minimum number of elements, in order to get a valid sequence. Print the minimum number of changes and an example of a valid sequence after that number of changes. If there are many valid sequences achievable
in the minimum number of changes, print any of them.

Input

The first line of the input contains an integer n (2 ≤ n ≤ 200 000) —
the number of vertices in the tree.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n).

Output

In the first line print the minimum number of elements to change, in order to get a valid sequence.

In the second line, print any valid sequence possible to get from (a1, a2, ..., an) in
the minimum number of changes. If there are many such sequences, any of them will be accepted.

Examples

input
4
2 3 3 4


output
1
2 3 4 4


input
5
3 2 2 5 3


output
0
3 2 2 5 3


input
8
2 3 5 4 1 6 6 7


output
2
2 3 7 8 1 6 6 7


Note

In the first sample, it's enough to change one element. In the provided output, a sequence represents a tree rooted in a vertex 4 (because p4 = 4),
which you can see on the left drawing below. One of other correct solutions would be a sequence 2 3 3 2, representing a tree rooted in vertex 3 (right
drawing below). On both drawings, roots are painted red.



In the second sample, the given sequence is already valid.

ps:题意就是要用最少的步骤把这个图变成一个树,并且输出每一个节点的父节点

很容易想到用并查集,而成树要满足两个条件:1.只有一个根节点;2.图中无环

所以我们可以在输入的时候判断是否有根节点出现,然后在遍历时判断一下是否只有一个根结点,并且判断每一个的节点和它暂定的父节点是否成环

代码:
#include<stdio.h>

#define maxn 200000+10
int pre[maxn],a[maxn];
int n;

int Find(int x)
{
if(x==pre[x])
return x;
return pre[x]=Find(pre[x]);
}

void join(int x,int y)
{
int fx=pre[x],fy=pre[y];
if(fx!=fy)
pre[fx]=fy;
}

int main()
{
scanf("%d",&n);
int root=-1,i;
for(i=1; i<=n; i++)
{
scanf("%d",&a[i]);
pre[i]=i;
if(i==a[i])
root=i;
}
int cnt=0;
for(i=1; i<=n; i++)
{
if(i==a[i]&&i!=root)
{
cnt++;
a[i]=root;
join(i,a[i]);
}
else if(a[i]!=i)
{
if(Find(i)!=Find(a[i]))
join(i,a[i]);
else
{
cnt++;
if(root==-1)
root=i;
a[i]=root;
join(i,a[i]);
}
}
}
printf("%d\n",cnt);
for(int i=1; i<=n; i++)
{
if(i!=n)
printf("%d ",a[i]);
else
printf("%d\n",a[i]);
}
return 0;
}


总结:
一开始我直接把输入的数据就设为了对应节点的父节点,所以在接下来判环的时候非常困难,而这道题是,输入的时候并不是要直接设为父节点,而是先找有没有根节点,然后再判断是否成环进行合并
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: